// Consider this to be on a BSD style license
// For licensing details contant me at gynvael@coldwind.pl
#pragma once
#include <windows.h>
#include <winsock.h>
#include <cstdio>

using namespace std;

class NetSock
{
private:
  unsigned int    ip;
  unsigned short  port;
  int   mode;
  int   socket;
  char  str_ip[16];
  static bool WinSockInited;

public:
  NetSock();
  ~NetSock();

  static const int SYNCHRONIC;
  static const int ASYNCHRONIC;

  bool Connect(const char* host, unsigned short port);
  bool Connect(unsigned int ip, unsigned short port);
  bool SetMode(int mode);
  bool Disconnect();
  bool Listen(unsigned short port);
  NetSock *Accept();
  int Read(unsigned char *Buffer, int Size);
  int Write(unsigned char *Buffer, int Size);
  unsigned short GetPort() const;
  unsigned int GetIP() const;
  const char *GetStrIP();
};

