@echo off

call :gl.init

set r=0

:loop
  !gl.LockRender!
  !gl.ClearRender!
  !gl.Translatef! 0 0 -10
  !gl.PushMatrix!
  !gl.Rotatef! !r! 1 0.3 0.2
  !gl.Begin! GL_TRIANGLES
  !gl.Color3f! 1 0 0!
  !gl.Vertex3f! 0 1 0
  !gl.Color3f! 0 1 0
  !gl.Vertex3f! -1 -1 0
  !gl.Color3f! 0 0 1
  !gl.Vertex3f! 1 -1 0
  !gl.End!
  !gl.PopMatrix!
  !gl.UnlockRender!
  set /a r=!r!+20
goto loop


goto :EOF


rem Class GL
rem Methods: .Translatef .PushMatrix .PopMatrix .Begin .End .Color3f .Vertex3f .LockRender .UnlockRender .ClearRender

:gl.init
start GLDaemon
sleep 2
set gl.Translatef=call :gl.Translatef
set gl.PushMatrix=call :gl.PushMatrix
set gl.PopMatrix=call :gl.PopMatrix
set gl.Begin=call :gl.Begin
set gl.End=call :gl.End
set gl.Color3f=call :gl.Color3f
set gl.Vertex3f=call :gl.Vertex3f
set gl.Rotatef=call :gl.Rotatef
set gl.LockRender=call :gl.LockRender
set gl.UnlockRender=call :gl.UnlockRender
set gl.ClearRender=call :gl.ClearRender
goto :EOF

:gl.LockRender
GLOpcode "L"
goto :EOF

:gl.UnlockRender
GLOpcode "U"
goto :EOF

:gl.ClearRender
GLOpcode "C"
goto :EOF

:gl.Translatef
GLOpcode "AglTranslatef %1 %2 %3"
goto :EOF

:gl.PushMatrix
GLOpcode "AglPushMatrix"
goto :EOF

:gl.PopMatrix
GLOpcode "AglPopMatrix"
goto :EOF

:gl.Begin
GLOpcode "AglBegin %1"
goto :EOF

:gl.End
GLOpcode "AglEnd"
goto :EOF

:gl.Color3f
GLOpcode "AglColor3f %1 %2 %3"
goto :EOF

:gl.Vertex3f
GLOpcode "AglVertex3f %1 %2 %3"
goto :EOF

:gl.Rotatef
GLOpcode "AglRotatef %1 %2 %3 %4"
goto :EOF

